/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_ws.deployment.xml;

// Global Interface Import Statements
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;

// Local Interface Import Statements
import java.util.List;
import java.io.Serializable;

public interface JavaXmlTypeMapping extends Serializable {

    public static final String ZEUS_XML_NAME = "java-xml-type-mapping";
    public static final String[] ZEUS_ATTRIBUTES = {"id"};
    public static final String[] ZEUS_ELEMENTS = {"class-type", "root-type-qname", "qname-scope", "variable-mapping"};

    public ClassType getClassType();

    public void setClassType(ClassType classType);

    public RootTypeQname getRootTypeQname();

    public void setRootTypeQname(RootTypeQname rootTypeQname);

    public QnameScope getQnameScope();

    public void setQnameScope(QnameScope qnameScope);

    public List getVariableMappingList();

    public void setVariableMappingList(List variableMappingList);

    public void addVariableMapping(VariableMapping variableMapping);

    public void removeVariableMapping(VariableMapping variableMapping);

    public String getId();

    public void setId(String id);

    public void marshal(File file) throws IOException;

    public void marshal(OutputStream outputStream) throws IOException;

    public void marshal(Writer writer) throws IOException;

    public void setDocType(String name, String publicID, String systemID);

    public void setOutputEncoding(String outputEncoding);

}
