/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_web.deployment.xml;

// Global Interface Import Statements
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;

// Local Interface Import Statements
import java.util.List;
import java.io.Serializable;

public interface JonasWebApp extends Serializable {

    public static final String ZEUS_XML_NAME = "jonas-web-app";
    public static final String[] ZEUS_ATTRIBUTES = {};
    public static final String[] ZEUS_ELEMENTS = {"jonas-resource-env", "jonas-resource", "jonas-ejb-ref", "jonas-service-ref", "host", "context-root", "port", "java2-delegation-model"};

    public List getJonasResourceEnvList();

    public void setJonasResourceEnvList(List jonasResourceEnvList);

    public void addJonasResourceEnv(JonasResourceEnv jonasResourceEnv);

    public void removeJonasResourceEnv(JonasResourceEnv jonasResourceEnv);

    public List getJonasResourceList();

    public void setJonasResourceList(List jonasResourceList);

    public void addJonasResource(JonasResource jonasResource);

    public void removeJonasResource(JonasResource jonasResource);

    public List getJonasEjbRefList();

    public void setJonasEjbRefList(List jonasEjbRefList);

    public void addJonasEjbRef(JonasEjbRef jonasEjbRef);

    public void removeJonasEjbRef(JonasEjbRef jonasEjbRef);

    public List getJonasServiceRefList();

    public void setJonasServiceRefList(List jonasServiceRefList);

    public void addJonasServiceRef(JonasServiceRef jonasServiceRef);

    public void removeJonasServiceRef(JonasServiceRef jonasServiceRef);

    public Host getHost();

    public void setHost(Host host);

    public ContextRoot getContextRoot();

    public void setContextRoot(ContextRoot contextRoot);

    public Port getPort();

    public void setPort(Port port);

    public Java2DelegationModel getJava2DelegationModel();

    public void setJava2DelegationModel(Java2DelegationModel java2DelegationModel);

    public void marshal(File file) throws IOException;

    public void marshal(OutputStream outputStream) throws IOException;

    public void marshal(Writer writer) throws IOException;

    public void setDocType(String name, String publicID, String systemID);

    public void setOutputEncoding(String outputEncoding);

}
